#ifndef __PokktExtension__
#define __PokktExtension__

#include <stdio.h>
#include <stdlib.h>
#include <string>
#include "PokktNativeExtension.h"

class PokktExtension
{
    friend class PokktNativeManager;
    friend class PokktMarmaladeConfig;
    
public:
    
    typedef enum __pokktOperations
    {
        // common methods
        SetParams,
        SetDebug,
        ShowLog,
        ShowToast,
        SetThirdPartyUserId,
        
        // session methods
        StartSession,
        EndSession,
        
        // Offerwall Methods
        SetCloseOnSuccessFlag,
        GetCoins,
        GetPendingCoins,
        CheckOfferWallCampaign,
        
        // Video Methods
        GetVideo,
        GetVideoNonIncent,
        CacheVideoCampaign,
        SetSkipEnabled,
        SetDefaultSkipTime,
        SetCustomSkipMessage,
        SetBackButtonDisabled,
        
        // Optional Methods
        SetName,
        SetAge,
        SetSex,
        SetMobileNo,
        SetEmailAddress,
        SetLocation,
        SetBirthday,
        SetMaritalStatus,
        SetFacebookId,
        SetTwitterHandle,
        SetEducation,
        SetNationality,
        SetEmployment,
        SetMaturityRating,
    } PokktOperations;
    
protected:
    
    static void PokktCallbackReceived(CallbackData* data, void* userData);
    
    // use this to notify native pokkt runtime
    static void notifyNative(std::string operation, std::string param = "");
    
    // use this to check for video availability
    static bool isVideoAvailable();
    
    // use this to get the coin associated
    static double getVideoVc();
    
    // generic
    static void performOperation(PokktOperations operation, std::string param = "");
    
    // sdk version
    static std::string getPokktSDKVersion();
    
private:
};

#endif /* defined(__PokktExtension__) */
