//
//  PokktMarmaladeConfig.h
//  PokktSample
//
//  Created by Pankaj Kumar on 18/06/15.
//
//

#ifndef __PokktSample__PokktMarmaladeConfig__
#define __PokktSample__PokktMarmaladeConfig__

#include <stdio.h>
#include <string>
#include "PokktExtension.h"

class PokktMarmaladeConfig
{
    friend class PokktExtension;
    
public:
    typedef enum __pokktIntegrationType
    {
        // common methods
        INTEGRATION_TYPE_ALL,
        INTEGRATION_TYPE_OFFERWALL,
        INTEGRATION_TYPE_VIDEO,
    } PokktIntegrationType;
    
private:
    
    // common methods
    std::string applicationId;
    std::string securityKey;
    PokktIntegrationType integrationType;
    bool autoCacheVideo;
    std::string thirdPartyUserId;
    
    // offer wall specific
    std::string offerWallAssetValue;
    bool closeOnSuccessFlag;
    
    // video campaign specific
    bool skipEnabled;
    int defaultSkipTime;
    std::string customSkipMessage;
    std::string screenName;
    bool incentivised;
    bool backButtonDisabled;
    
    // optional methods
    std::string name;
    std::string age;
    std::string sex;
    std::string mobileNo;
    std::string emailAddress;
    std::string location;
    std::string birthday;
    std::string maritalStatus;
    std::string facebookId;
    std::string twitterHandle;
    std::string education;
    std::string nationality;
    std::string employment;
    std::string maturityRating;
    
public:
    
    
    // common methods
    void setApplicationId(std::string applicationId);
    std::string getApplicationId();
    void setSecurityKey(std::string securityKey);
    std::string getSecurityKey();
    void setIntegrationType(PokktMarmaladeConfig::PokktIntegrationType integrationType);
    PokktMarmaladeConfig::PokktIntegrationType getIntegrationType();
    void setAutoCacheVideo(bool autoCacheVideo);
    bool getAutoCacheVideo();
    void setThirdPartyUserId(std::string thirdPartyUserId);
    std::string getThirdPartyUserId();
    
    // offerwall methods
    void setOfferWallAssetValue(std::string offerWallAssetValue);
    std::string getOfferWallAssetValue();
    void setCloseOnSuccessFlag(bool closeOnSuccessFlag);
    bool getCloseOnSuccessFlag();
    
    // video methods
    void setSkipEnabled(bool skipEnabled);
    bool getSkipEnabled();
    void setDefaultSkipTime(int defaultSkipTime);
    int getDefaultSkipTime();
    void setCustomSkipMessage(std::string customSkipMessage);
    std::string getCustomSkipMessage();
    void setScreenName(std::string screenName);
    std::string getScreenName();
    void setIncentivised(bool incentivised);
    bool getIncentivised();
    void setBackButtonDisabled(bool backButtonDisabled);
    bool getBackButtonDisabled();
    
    // optional methods
    void setName(std::string name);
    std::string getName();
    void setAge(std::string age);
    std::string getAge();
    void setSex(std::string sex);
    std::string getSex();
    void setMobileNo(std::string mobileNo);
    std::string getMobileNo();
    void setEmailAddress(std::string emailAddress);
    std::string getEmailAddress();
    void setLocation(std::string location);
    std::string getLocation();
    void setBirthday(std::string birthday);
    std::string getBirthday();
    void setMaritalStatus(std::string maritalStatus);
    std::string getMaritalStatus();
    void setFacebookId(std::string facebookId);
    std::string getFacebookId();
    void setTwitterHandle(std::string twitterHandle);
    std::string getTwitterHandle();
    void setEducation(std::string education);
    std::string getEducation();
    void setNationality(std::string nationality);
    std::string getNationality();
    void setEmployment(std::string employment);
    std::string getEmployment();
    void setMaturityRating(std::string maturityRating);
    std::string getMaturityRating();
    
};

#endif /* defined(__PokktSample__PokktMarmaladeConfig__) */
