//
//  VideoScreen.h
//  PokktSample
//
//  Created by Pankaj Kumar on 22/04/15.
//
//

#ifndef __PokktSample__VideoScreen__
#define __PokktSample__VideoScreen__

#include "scene.h"
#include <string>
#include "PokktMarmaladeConfig.h"
#include "PokktDelegate.h"

class VideoScreen : public Scene, public PokktDelegate
{
private:
    // pokkt handlers
    void handleVideoClosed(std::string message);
    void handleVideoDisplayed(std::string message);
    void handleVideoSkipped(std::string message);
    void handleVideoCompleted(std::string message);
    void handleVideoGratified(std::string coins);
    void handleDownloadCompleted(std::string coinsToEarn);
    void handleDownloadFailed(std::string message);
    
    float _coinsEarned = 0;
    CLabel* startCachingLbl;
    
    static PokktMarmaladeConfig *pokktConfig;
    
protected:
    CSprite* startCachingBtn;
    CSprite* playIncentBtn;
    CSprite* playNonIncentBtn;
    CSprite* playWithIntentBtn;
    
    CLabel* playIncentLbl;
    CLabel* playNonIncentLbl;
    
    CLabel* pointsEarnedLbl;
    CLabel* msgLbl;
    
public:
    VideoScreen();
    ~VideoScreen();
    
    //
    void Init();
    void Update(float deltaTime = 0.0f, float alphaMul = 1.0f);
    void Render();
    void initPokkt();
};

#endif /* defined(__PokktSample__VideoScreen__) */
